% Skript, jeho kolem je porovnat rychlost rznch algoritm hledn
% prvosel do zadan meze 2000

clear,clc
matlab=zeros(1,2000);       % Vytvoen matice k ukldn as vestavn funkce PRIMES
mojeFunkce=zeros(1,2000);   % Vyvoen mnatice k ukldn as funkce PRVOCISLA (verze 1)
mojeFunkce2=zeros(1,2000);  % Vyvoen mnatice k ukldn as funkce PRVOCISLA (verze 2)
mojeFunkce3=zeros(1,2000);  % Vyvoen mnatice k ukldn as funkce PRVOCISLA (verze 3)

h = waitbar(0,'Prosm ekejte, probh vpoet...','Name',sprintf('Sto %d ',i));   % Vytvoen waitbaru indikujc prbh vpotu (ukazuje zvtujc se erven pruh a hotov procenta z celho men)
kroku=2000;                 % Zadn potu krok pro waitbar

for a=1:2000                % Cyklus zvtujc zadanou mez pro men ve funkcch
    tic;
    primes(a);              % Hledn prvosel do urit meze funkc PRIMES
    toc;                    % Zmen asu
    matlab(a) = toc;        % Uloen asu pro uritou mez
    
    tic;
    prvocisla(a);           % Hledn prvosel do urit meze funkc prvocisla
    toc;                    % Zmen asu
    mojeFunkce(a)=toc;      % Uloen asu pro uritou mez
    
    tic;  
    prvocisla2(a);          % Hledn prvosel do urit meze funkc prvocisla2
    toc;                    % Zmen asu
    mojeFunkce2(a)=toc;     % Uloen asu pro uritou mez
    
    tic;   
    prvocisla3(a);          % Hledn prvosel do urit meze funkc prvocisla3
    toc;                    % Zmen asu
    mojeFunkce3(a)=toc;     % Uloen asu pro uritou mez
    
    i=i+1;                  % Hotov jeden cyklus, zven stavu na waitbaru o jeden krok
    waitbar(i/kroku);       % Zobrazen zmny na waitbar
    set(h,'Name',sprintf('Eratosthenovo sto (hotovo %2.0f %%)',i/kroku*100));      % Zmna procent hotovho na waitbaru
    
end

waitbar(2000,h,'Hotovo');   % Zobrazen na waitbaru konec vpot

Monitor = get(0,'ScreenSize');  % Zskn rozlien monitoru
velikostX  = 1024/(1280/Monitor(3));      % Konstanta podle velikosti monitoru pro velikost okna s vsledky v ose X
velikostY  = 640/(800/Monitor(4));       % Konstanta podle velikosti monitoru pro velikost okna s vsledky v ose Y

fig = figure('units','pixels','Name','Vsledek vpot','Position', ...
    [Monitor(3)/2-velikostX/2 Monitor(4)/2-velikostY/2 velikostX velikostY], ...
    'Tag','fig_Priklad','Menu','none', ...
    'NumberTitle','off','color','w');       % Nastaven vlastnost figure, ve kterm budou zobrazeny vsledky
plot(matlab);           % Vykreslen grafu zmench as y funkce PRIMES
hold on;
plot(mojeFunkce,'r');   % Vykreslen grafu zmench as y funkce prvocisla
hold on;
plot(mojeFunkce2,'m');  % Vykreslen grafu zmench as y funkce prvocisla2
hold on;
plot(mojeFunkce3,'g');  % Vykreslen grafu zmench as y funkce prvocisla3
xlim([1 2000]);         % Nastaven mez osy X na grafu
grid on;                % Zapnut mky v grafu
legend('funkce Matlabu PRIMES', 'funkce PRVOCISLA verze 1', 'funkce PRVOCISLA verze 2','funkce PRVOCISLA verze 3');
            % Zadn popisk v legend v grafu
xlabel('Zadan mez hledn prvosel');                     % Popisek osy X
ylabel('Rychlost hledn prvosel u dan funkce [s]');     % Popisek osy Y
ylim([0 2*10^-2]);                                          % Nastaven mez osy Y na grafu
title('Graf porovnn rychlost hledn prvosel jednotlivch verz funkce ''prvocisla'' a vestavn funkce ''primes''','FontSize',12);
            % Zadn popisku nad grafem
if isequal(prvocisla3(2000),primes(2000))==1                % Podmnka zkouejc, zda nalezen prvosla do 2000 se shoduj u funkc prvocisla3 a PRIMES
    text='Pozn.: Vpis vech prvosel do 2000 je u konen verze 3 toton s funkc primes';   % Vypsn vsledku podle podmnky
else
    text='Pozn.: Vpis vech prvosel do 2000 nen shodn u konen verze 3 s funkc primes';  % Vypsn vsledku podle podmnky
end

text1=uicontrol('Style','Text','Units','Normalized','Position',[0.1 0.001 0.8 0.03],'String',text,'background','w'); 
            % Vypsn textu s vsledkem zkouky pod grafem

close(h);   % Ve je hotovo, uzaven waitbaru